<?php

namespace Services\Logic;
use TecFoodMobile\Runtime\Framework;

/**
 * Created by JetBrains PhpStorm.
 * User: marcellichtnow
 * Date: 12/08/13
 * Time: 15:10
 * To change this template use File | Settings | File Templates.
 */
class VerificaParametros
{

   public static function verificaStatusInsert(){
      $entidade = \Facilities\Entities\FctParametrogeral::getObjectByWhere("NRORG = ".\Geral\Util\Ambiente::getNrorg());
      return $entidade;
   }

   public static function verificaCdhabilitserv($Cdhabilitserv){
      $entidade = \Facilities\Entities\FctHabilitserv::getObjectByWhere("CDHABILITSERV = ".$Cdhabilitserv);
      return $entidade;
   }

   public static function verificaCdservorca($cdservorca,$nrorg){
      $entidade = \Facilities\Entities\FctServicoorca::getObjectByWhere('NRORG = :NRORG AND CDSERVORCA = :CDSERVORCA',array(":NRORG" => $nrorg, ":CDSERVORCA" => $cdservorca));
      return $entidade;
   }

   public static function verificaNrseqmodcontra($nrseqmodcontra){
      try{
         $nrorg = \Geral\Util\Ambiente::getNrorg();

         $entidade = \Facilities\Entities\FctModelocontrato::getObjectByWhere("NRSEQMODCONTRA = ".$nrseqmodcontra." AND NRORG = ".$nrorg);
      }catch(\Exception $e){
         tk_warning($e->getMessage());
      }
      return $entidade;
   }

   public static function verificaNrmodelodocfct($nrmodelodocfct,$ididioma = null){
      if(!empty($ididioma)){
         $entidade = \Geral\Entities\FctModelodoc::getObjectByWhere('NRMODELODOCFCT = :NRMODELODOCFCT AND IDIDIOMA = :IDIDIOMA', array(":NRMODELODOCFCT" => $nrmodelodocfct, ":IDIDIOMA" => $ididioma));
      }else{
         $entidade = \Geral\Entities\FctModelodoc::getObjectByWhere('NRMODELODOCFCT = :NRMODELODOCFCT',array(":NRMODELODOCFCT" => $nrmodelodocfct));
      }
      return $entidade;

   }

   public static function verificaModeloDocContr($nrseqmoddocfct,$nrseqmodcontra){
      $entidade = \Geral\Entities\FctModelodoccontr::findOneByNrseqmoddocfctAndNrseqmodcontra($nrseqmoddocfct,$nrseqmodcontra);
      return $entidade;
   }

   public static function verificaModeloDocContrPadrao($idmodpadrao,$nrseqmodcontra){
      $entidade = \Geral\Entities\FctModelodoccontr::getObjectByWhere(
            'IDMODPADRAO = :IDMODPADRAO AND NRSEQMODCONTRA = :NRSEQMODCONTRA',
            array(
                ":IDMODPADRAO"       => $idmodpadrao,
                "NRSEQMODCONTRA"  => $nrseqmodcontra
            )
        );

        return $entidade;

    }

    public static function verificaTradidioma($ididioma){


        $entidade = \Geral\Entities\Tradidioma::getObjectByWhere(
            'IDIDIOMA = :IDIDIOMA AND NRORG = :NRORG',
            array(
                ":IDIDIOMA"      => $ididioma,
                ":NRORG" => \Geral\Util\Ambiente::getNrorg()
            )
        );

        return $entidade;

    }

    public static function verificaNrseqcontrato($Nrseqcontrato){


        $entidade = \Facilities\Entities\FctContrato::getObjectByWhere(
            'NRSEQCONTRATO = :NRSEQCONTRATO AND NRORG = :NRORG',
            array(
                ":NRSEQCONTRATO"      => $Nrseqcontrato,
                ":NRORG" => \Geral\Util\Ambiente::getNrorg()
            )
        );
        return $entidade;

    }

    public static function ValidaPeriodo($DataIni,$DataFin){

        If ($DataFin < $DataIni ){

            tk_show_message_by_name('msg_valida_data');
            tk_abort();
        }

    }
    public static function verificaNrseqcontratoVersao($versao,$nrcontratofct = null){
        
        if(!empty($nrcontratofct)){
            $entidade = \Facilities\Entities\FctContrato::getObjectsByWhere(
                'NRCONTRATOFCT = :NRCONTRATOFCT AND NRVERSAOCONTRATO = :VERSAO AND NRORG = :NRORG',
                array(
                    ":NRCONTRATOFCT"      => $nrcontratofct,
                    ":VERSAO"      => $versao,
                    ":NRORG" => \Geral\Util\Ambiente::getNrorg()
                )
            );
        }
        else{
            //tk_warning('tete');
      
            $entidade = \Facilities\Entities\FctContrato::getObjectsByWhere(
                'NRVERSAOCONTRATO = :VERSAO AND NRORG = :NRORG',
                array(
                    ":VERSAO"      => $versao,
                    ":NRORG" => \Geral\Util\Ambiente::getNrorg()
                )
            
            );
       
        }

        return $entidade;

    }

    public static function updateContratoPorrogAntec($nrseqcontrato,$nrorg,$dtinicio,$dtfim){

        $connection = \Setforms2\Shared\Registry::getEntityManager()->getConnection();
        $connection->beginTransaction();
        try{
            $entidade = \Facilities\Entities\FctContrato::getObjectByWhere(
                'NRSEQCONTRATO = :NRSEQCONTRATO AND NRORG = :NRORG',
                array(
                    ":NRSEQCONTRATO"    => $nrseqcontrato,
                    ":NRORG"            => $nrorg
                )
            );

            /* @var $entidade \Facilities\Entities\FctContrato */

            $dtinicio = explode(" ",$dtinicio);
            $dtfim = explode(" ",$dtfim);

            $dtinicio = "$dtinicio[0] 00:00:00";
            $dtfim = "$dtfim[0] 00:00:00";

            $dtinicio = \Geral\Util\DateUtil::getDataDeString($dtinicio, \Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            $dtfim = \Geral\Util\DateUtil::getDataDeString($dtfim, \Geral\Util\DateUtil::FORMATO_BRASILEIRO_DATAHORA);
            //Vai ser usada para ser setada no campo da tabele FCT_CONTRATO campo NRDIASPRORGCONT
            //tk_warning('Passou pela Procedure');
            $quantdatas = \Geral\Util\DateUtil::getQtdeDiasEntre($dtinicio,$dtfim);
            $entidade->setDtinivigencont($dtinicio);
            $entidade->setDtfinvigencont($dtfim);
            $entidade->setNrdiasprorgcont($quantdatas);
            //$entidade->setDtiniciocontrato($dtinicio);
            //$entidade->setDtfimcontrato($dtfim);

            $entidade->persist();

            \Setforms2\Shared\Registry::getEntityManager()->flush();
            $connection->commit();
            tk_show_message_by_name('msg_contrato_salvo');
        } catch(\Exception $e){
            tk_warning($e->getMessage());
            $connection->rollBack();
            tk_show_message_by_name('msg_falha_conexao');
        }
    }

    public static function validaIddtativo($nrseqprorrcont,$nrseqcontrato,$nrorg,$iddtativo){

        if($iddtativo === "S"){

            try{
                $entidade = \Facilities\Entities\FctProrrogcontrato::getObjectsByWhere(
                    'NRSEQCONTRATO = :NRSEQCONTRATO AND NRORG = :NRORG',
                    array(
                        ":NRSEQCONTRATO"    => $nrseqcontrato,
                        ":NRORG"            => $nrorg
                    )
                );

                /* @var $entidade \Facilities\Entities\FctProrrogcontrato */
                /* @var $registro \Facilities\Entities\FctProrrogcontrato */
                $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
                    $connection->beginTransaction();
                foreach ($entidade as $registro) {
                   
                    $nrseqprorrcontEntidade = $registro->getNrseqprorrcont();

                    if($nrseqprorrcontEntidade == $nrseqprorrcont){
                        $registro->setIddtativo("S");
                    }
                    else{
                        $registro->setIddtativo("N");
                    }
                    
                    $registro->persist();
                }

                \Setforms2\Shared\Registry::getEntityManager()->flush();

                
                $connection->commit();
            }
            catch(\Exception $e){
                tk_warning($e->getMessage());
                $connection->rollBack();
                tk_show_message_by_name('msg_falha_conexao');
            }

        }

    }

    public static function verificaNrseqmoddocfct($nrseqmoddocfct){


        $entidade = \Geral\Entities\FctModelodoc::getObjectByWhere(
            'NRSEQMODDOCFCT = :NRSEQMODDOCFCT AND NRORG = :NRORG',
            array(
                ":NRSEQMODDOCFCT"      => $nrseqmoddocfct,
                ":NRORG" => \Geral\Util\Ambiente::getNrorg()
            )
        );
        return $entidade;

    }

    public static function setaHTML($nome,$valor){


        $valor = preg_replace('#<script(.*?)>(.*?)</script>#is', '', $valor);

        self::tkSetFieldValue($nome, $valor);




    }

    private function tkSetFieldValue($name, $value, $tab_name = null, $window_name = null)
    {
        $mapper = \Setforms2\Runtime\Framework::getInstance()->getCurrentMapper();
        $rowId = $mapper instanceof \Setforms2\Runtime\Mapper\Crud ? $mapper->getRowId() : -1;
        // if setting fields of different tab the rowId is not considered
        if (($tab_name != null && $tab_name != $mapper->getTabName()) || $rowId == null) {
            $rowId = -1;
        }

//        $value =is_string($value) ? htmlspecialchars($value) : $value;
        \Setforms2\Runtime\Framework::getInstance()->setFieldValue($name, $value, $rowId, $tab_name, $window_name);
    }

    public static function verificaNrseqmodeloccontr($nrseqmodcontra){

        $nrorg = \Geral\Util\Ambiente::getNrorg();
        
        $entidade = \Geral\Entities\FctModelodoccontr::getObjectByWhere("NRSEQMODCONTRA = $nrseqmodcontra AND NRORG = $nrorg AND IDMODPADRAO = 'S'");
        return $entidade;


    }

    public static function verificaPadrao($opcao,$nrseqcontdoc,$nrseqcontrato){
        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();  
        $connection->beginTransaction();          
        try{

            $entidades = \Facilities\Entities\FctContratodoc::getObjectsByWhere("NRSEQCONTRATO = $nrseqcontrato");
            
            
                
                /* @var $entidades \Facilities\Entities\Fctcontratodoc */
                /* @var $registro \Facilities\Entities\Fctcontratodoc */
                
                
                        

                if($opcao === "confirmar"){
                    foreach ($entidades as $registro) {
                
                        $nrseqcontdocEntidade = $registro->getNrseqcontdoc();

                        if($nrseqcontdocEntidade == $nrseqcontdoc){
                            $registro->setIdpadrao("S");                            
                        }
                        else{
                            $registro->setIdpadrao("N");                            
                        }
                                                
                    }
                }
                else{
                    
                    foreach ($entidades as $registro) {
var_dump($registro instanceof \Facilities\Entities\FctContratodoc);return;
                        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
                        $connection->beginTransaction();
                
                        $nrseqcontdocEntidade = $registro->getNrseqcontdoc();

                        if($nrseqcontdocEntidade == $nrseqcontdoc){
                            tk_set_field_value("IDPADRAO","N");
                            $registro->setIdpadrao("N");
                                                        
                        }
                            
                    }
                }                

                \Setforms2\Shared\Registry::getEntityManager()->flush();
                $connection->commit();
                                
            
        }
        catch(\Exception $e){
            tk_warning($e->getMessage());
            $connection->rollBack();
            tk_show_message_by_name('msg_falha_conexao');
        }    
    }
    
    public static function updateIdbemaloc($nrorg,$cdempresa,$cdbemativo,$idbemaloc){ 

        $sql = 'UPDATE BEMATIVO 
                   SET IDBEMALOC = :IDBEMALOC
                 WHERE CDEMPRESA = :CDEMPRESA
                   AND CDBEMATIVO = :CDBEMATIVO
                   AND NRORG = :NRORG';

        $params = array("CDEMPRESA"=>$cdempresa,
                        "CDBEMATIVO"=>$cdbemativo,
                        "NRORG"=>$nrorg,
                        "IDBEMALOC"=>$idbemaloc);
        try{
                        
           @\Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }
    }

    public static function updateIdrecurativ($nrorg,$nrseqrecucont,$idrecurativ){ 

        $sql = 'UPDATE FCT_RECURSOSCONTR 
                   SET IDRECURATIV = :IDRECURATIV
                 WHERE NRSEQRECUCONT = :NRSEQRECUCONT
                   AND NRORG = :NRORG';

        $params = array("NRSEQRECUCONT"=>$nrseqrecucont,
                        "NRORG"=>$nrorg,
                        "IDRECURATIV"=>$idrecurativ);
        try{
                        
           @\Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }
    }

    public static function updIdbemaloc(array $bens){

        if(is_array($bens)){
            $nrorg = \Geral\Util\Ambiente::getNrorg();
            foreach($bens as $bem){
                $cdbemativo = $bem['CDBEMATIVO'];
                $cdempresa = $bem['CDEMPRESA'];
                @\Services\Logic\VerificaParametros::updateIdbemaloc($nrorg,$cdempresa,$cdbemativo,'S');
            }


        }
    }
   public static function getBensRecurso($nrseqcontrato, $nrseqrecurso){
   
        if($nrseqrecurso != null){
            $where = "AND INSTR('_'||:P_RECURSO||'_','_'||NRSEQRECUCONT||'_')>0";
        }else{
            $where = "AND NRSEQCONTRATO = :NRSEQCONTRATO";
        }
        
        $sql = "SELECT CDBEMATIVO, CDEMPRESA
                  FROM FCT_RECURSOSCONTR
                 WHERE NRORG = :NRORG 
                       $where";


        $params = array('NRSEQCONTRATO'=>$nrseqcontrato,
                        'P_RECURSO'=>$nrseqrecurso,
                         'NRORG'=>\Geral\Util\Ambiente::getNrorg());


         
         try{
                        
           return \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);
        }catch(\Exception $e){
            tk_warning($e->getMessage());
        }

    }

   public static function isParcelaPendente($nrorg, $nrseqcontrato){
      $sql = 'SELECT COUNT(*) AS QT FROM FCT_VENCPREVCONT VENC
               WHERE VENC.NRORG = :NRORG
                 AND VENC.NRSEQCONTRATO = :NRSEQCONTRATO
                 AND VENC.NRAPURACAO IS NULL';
      $params = array('NRORG'=>$nrorg,'NRSEQCONTRATO'=>$nrseqcontrato);
      try{
          $qt = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);
          $qt = $qt[0]['QT'];
          if($qt == '0'){
             return false;
          }else{
              return true;
          }
      }catch(\Exception $e){
          tk_abort($e->getMessage());
      }

   }

   public static function isBemAloc($nrorg, $nrseqcontrato){
      $sql = 'SELECT COUNT(*) AS QT FROM FCT_RECURSOSCONTR REC, BEMATIVO BA
               WHERE REC.NRORG = :NRORG
                 AND REC.NRSEQCONTRATO = :NRSEQCONTRATO
                 AND REC.CDBEMATIVO = BA.CDBEMATIVO
                 AND REC.IDTPRECURSO = \'A\'
                 AND REC.IDRECURATIV = \'S\'
                 AND BA.IDBEMALOC = \'S\'';
      $params = array('NRORG'=>$nrorg,'NRSEQCONTRATO'=>$nrseqcontrato);
      try{
          $qt = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);
          $qt = $qt[0]['QT'];
          if($qt == '0'){
             return false;
          }else{
              return true;
          }
      }catch(\Exception $e){
          tk_abort($e->getMessage());
      }
   }
   
   public static function isGrupoFaturaNull($nrorg, $nrseqcontrato){
      $sql = 'SELECT COUNT(*) AS QT FROM FCT_ITEMCONTRATO IT, FCT_PARAMFATITCONT PA, FCT_PARAMFATCONT PARAM
               WHERE IT.NRSEQCONTRATO = PA.NRSEQCONTRATO
                 AND IT.NRITEMOCONTRATO = PA.NRITEMOCONTRATO
                 AND IT.NRSEQCONTRATO = PARAM.NRSEQCONTRATO
                 AND IT.NRORG = PA.NRORG
                 AND IT.NRORG = :NRORG
                 AND IT.NRSEQCONTRATO = :NRSEQCONTRATO
                 AND PA.NRGRUPOFATURA IS NULL
                 AND PARAM.NRGRUPOFATURA IS NULL
                 AND IT.VRTOTITEMCONT > 0';
      $params = array('NRORG'=>$nrorg,'NRSEQCONTRATO'=>$nrseqcontrato);
      try{
          $qt = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);
          $qt = $qt[0]['QT'];
          if($qt == '0'){
             return false;
          }else{
              return true;
          }
      }catch(\Exception $e){
          tk_abort($e->getMessage());
      }
   }
   
   public static function isMaiorVersao($nrorg, $nrseqcontrato){
      $sql = 'SELECT COUNT(*) AS QT FROM FCT_CONTRATO CP 
               WHERE CP.NRSEQCONTRATO = :NRSEQCONTRATO
                 AND CP.NRORG = :NRORG
                 AND (((CP.NRSEQCONTRATOPAI IS NULL) AND NOT EXISTS( SELECT 1 
                                                                       FROM FCT_CONTRATO CF 
                                                                      WHERE CF.NRSEQCONTRATOPAI = CP.NRSEQCONTRATO
                                                                        AND CF.NRORG = CP.NRORG)) 
                 OR ((CP.NRSEQCONTRATOPAI IS NOT NULL) AND CP.NRVERSAOCONTRATO = (SELECT MAX(CF.NRVERSAOCONTRATO) AS NRVERSAOCONTRATO 
                                                                                    FROM FCT_CONTRATO CF  
                                                                                   WHERE CF.NRSEQCONTRATOPAI = CP.NRSEQCONTRATOPAI
                                                                                     AND CF.NRORG = CP.NRORG)))  ';


      $params = array('NRORG'=>$nrorg,'NRSEQCONTRATO'=>$nrseqcontrato);
      try{
          $qt = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql,$params);
          $qt = $qt[0]['QT'];
          if($qt == '0'){
             return false;
          }else{
             return true;
          }
      }catch(\Exception $e){
          tk_abort($e->getMessage());
      }
   }
   
   public static function encerraContrato(array $paramsUpd){
      $valor       = 'E';
      $situ        = "IDSITUACAOCONTRATO";
      $tab_name    = "tab_ZD_FCT00004_000";
      $window_name = "ZD_FCT00004_000";
      tk_set_field_value($situ, $valor);

      $sql = "UPDATE FCT_CONTRATO SET IDSITUACAOCONTRATO = '$valor'
             WHERE NRORG = :NRORG
               AND NRSEQCONTRATO = :NRSEQCONTRATO";

      $aux = @\Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $paramsUpd);
   }      
   
   //--------------------------------------------------------------------------------------------------------
   //Verifica Parametros do Relatione(CRM)
   //Busca o valor do campo IDOBRIGAINSCJUR da tabela PARARELATIONE (responsavel pela parametrização do CRM), este campo é responsavel por definir se a inscrição juridica será necessária nas telas de Lead ou Prospect
   //Na tela de parametrização o campo possui quatro valores: -Lead
   //                                                         -Prospect
   //                                                         -Ambos
   //                                                         -Não Obrigatório
   //Dependendo do valor do campo IDOBRIGAINSCJUR, vai ativar o requerimento da inscrição jurídica do Lead ou Prospect.
   //--------------------------------------------------------------------------------------------------------

   public static function verificaIdobrigainscjur($TelaOrigem,$campoPais,$inscricaoJuridica)
   {
      $resultado = true;
      $sql = 'SELECT IDOBRIGAINSCJUR AS ID FROM PARARELATIONE';
      $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql);
      $id = $retorno[0]['ID'];
      $inscricao = tk_get_field_value($inscricaoJuridica);
      $windowName = tk_get_active_window_name();
      $pais = tk_get_field_value($campoPais);
      $tamInscr = strlen($inscricao);

      if ($TelaOrigem == 'LEAD')
      {
        if (($id == 'NENHUM') || ($id == 'PROSPECT')) //Não é obrigatório
        {
          if ((($tamInscr != 14) && ($tamInscr != 11) && ($tamInscr != 0)) && ((strlen($pais) == 0) || ($pais == '0055')))
          {
            $resultado = false;
            tk_abort('Permitido salvar apenas o CPF ou o CNPJ como Nr. Inscrição do Lead.');
          }
        }
        else //É obrigatório
        {
          if (($tamInscr == 0) && ($pais == '0055'))
          {
            $resultado = false;
            tk_abort('Informar o campo Nr. Inscrição.');
          }
          else if ((($tamInscr != 14) && ($tamInscr != 11)) && ((strlen($pais) == 0) || ($pais == '0055')))
          {
            $resultado = false;
            tk_abort('Permitido salvar apenas o CPF ou o CNPJ como Nr. Inscrição do Lead.');
          }
        }
      }

      else if ($TelaOrigem == 'CONVERSAO')
      {
        if (($id == 'NENHUM') || ($id == 'LEAD')) //Não é obrigatório
        {
          if ((($tamInscr != 14) && ($tamInscr != 11) && ($tamInscr != 0)) && ((strlen($pais) == 0) || ($pais == '0055')))
          {
            $resultado = false;
            tk_message('Processo não executado! Permitido salvar apenas o CPF ou o CNPJ como Nr. Inscrição do Prospect.','ERROR');
          }
        }
        else //É obrigatório
        {
          if (($tamInscr == 0) && ($pais == '0055'))
          {
            $resultado = false;
            tk_message('Processo não executado! Informar o campo Nr. Inscrição.','ERROR');
          }
          else if ((($tamInscr != 14) && ($tamInscr != 11)) && ((strlen($pais) == 0) || ($pais == '0055')))
          {
            $resultado = false;
            tk_message('Processo não executado! Permitido salvar apenas o CPF ou o CNPJ como Nr. Inscrição do Prospect.','ERROR');
          }
        }
      }
      return $resultado;
   }

  public static function converteMaiuscula($texto, $acento = false) //Converte uma string para maiúscula. Se $acento = true, são retirados os acentos da string antes de converter.
  {
    if ($acento == false)
      $texto = self::retiraAcento($texto);

    if (!empty($texto))
    {
      $acentos = array('á'=>'Á', 'à'=>'À', 'ã'=>'Ã', 'â'=>'Â', 'ä'=>'Ä', 'é'=>'É', 'ê'=>'Ê', 'è'=>'È', 'ë'=>'Ë', 'í'=>'Í', 'ì'=>'Ì', 'ï'=>'Ï', 
                   'î'=>'Î', 'ó'=>'Ó', 'ô'=>'Ô', 'ò'=>'Ò', 'õ'=>'Õ', 'ö'=>'Ö', 'ú'=>'Ú', 'ü'=>'Ü', 'ù'=>'Ù', 'û'=>'Û', 'ç'=>'Ç', 'Á'=>'Á', 
                   'À'=>'À', 'Ã'=>'Ã', 'Â'=>'Â', 'Ä'=>'Ä', 'É'=>'É', 'Ê'=>'Ê', 'È'=>'È', 'Ë'=>'Ë', 'Í'=>'Í', 'Ì'=>'Ì', 'Ï'=>'Ï', 'Î'=>'Î', 
                   'Ó'=>'Ó', 'Ô'=>'Ô', 'Õ'=>'Õ', 'Ò'=>'Ò', 'Ö'=>'Ö', 'Ú'=>'Ú', 'Ù'=>'Ù', 'Û'=>'Û', 'Ü'=>'Ü', 'Ç'=>'Ç');
      $texto = str_replace('ú','#@U@#',$texto);
      $texto = str_replace('Ú','#@U@#',$texto);
      $texto = strtr($texto, $acentos);
      $texto = strtoupper($texto);
      $texto = str_replace('#@U@#','Ú',$texto);
    }
    return $texto;
  }

  public static function retiraAcento($texto) //Retira os acentos de uma string.
  {
    $acentos = array('á'=>'a', 'à'=>'a', 'ã'=>'a', 'â'=>'a', 'ä'=>'a', 'é'=>'e', 'ê'=>'e', 'è'=>'e', 'ë'=>'e', 'í'=>'i', 'ì'=>'i', 'ï'=>'i', 
                   'î'=>'i', 'ó'=>'o', 'ô'=>'o', 'ò'=>'o', 'õ'=>'o', 'ö'=>'o', 'ú'=>'u', 'ü'=>'u', 'ù'=>'u', 'û'=>'u', 'ç'=>'c', 'Á'=>'A', 
                   'À'=>'A', 'Ã'=>'A', 'Â'=>'A', 'Ä'=>'A', 'É'=>'E', 'Ê'=>'E', 'È'=>'E', 'Ë'=>'E', 'Í'=>'I', 'Ì'=>'I', 'Ï'=>'I', 'Î'=>'I', 
                   'Ó'=>'O', 'Ô'=>'O', 'Õ'=>'O', 'Ò'=>'O', 'Ö'=>'O', 'Ú'=>'U', 'Ù'=>'U', 'Û'=>'U', 'Ü'=>'U', 'Ç'=>'C');
    return strtr($texto, $acentos);
  }

  public static function verifIdBloqAlteraDados($modeloOrca, $nrorg)
  {

    $select = "SELECT IDBLOQALTERADADOS 
                 FROM FCT_ORCAMENTOMODELO 
                WHERE NRORCAMENTOMODELO = :NRORCAMENTOMODELO 
                  AND NRORG = :NRORG";
    $parametros = array(':NRORCAMENTOMODELO'=>$modeloOrca,
                                            ':NRORG'=>$nrorg);
    $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($select, $parametros);
    if(!empty($retorno))
    {
      $valorParam = $retorno[0]['IDBLOQALTERADADOS'];
      return $valorParam;
    }
  }

  public static function verifIdUtilizaHierServ($modeloOrca, $nrorg)
  {
    $select = "SELECT IDUTILIZAHIERSERV 
                 FROM FCT_ORCAMENTOMODELO 
                WHERE NRORCAMENTOMODELO = :NRORCAMENTOMODELO
                  AND NRORG = :NRORG";
    $parametros = array(':NRORCAMENTOMODELO'=>$modeloOrca,
                                            ':NRORG'=>$nrorg); 
    $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($select, $parametros);
    if(!empty($retorno))
    {
      $valorParam = $retorno[0]['IDUTILIZAHIERSERV'];
      return $valorParam;
    }
  }

  public static function verifIdBloqAltOrc($itModeloOrca, $nrorg)
  {
    $select = "SELECT IDBLOQALTORC 
                 FROM FCT_ITEMORCAMODELO
                WHERE NRITEMORCAMODELO = :NRITEMORCAMODELO
                  AND NRORG = :NRORG";
    $parametros = array(':NRITEMORCAMODELO'=>$itModeloOrca,
                                            ':NRORG'=>$nrorg); 
    $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($select, $parametros);
    if(!empty($retorno))
    {
      $valorParam = $retorno[0]['IDBLOQALTORC'];
      return $valorParam;
    } 
  }

    public static function verificaParceiro($parceiros)
    {
        if($parceiros != 'A' && $parceiros != 'N')//Só verifica se houver um parceiro
        {
            foreach ($parceiros as $values)//checa cada uma dos parceiros
            {
                $select = "SELECT PARCNEGOCIO.NRPARCNEGOCIO AS NRPARCNEGOCIO,
                                  PARCNEGOCIO.NRORG         AS NRORG,
                                  ENDERECOPARC.CDPAIS       AS CDPAIS
                              FROM PARCNEGOCIO LEFT JOIN ENDERECOPARC
                              ON ENDERECOPARC.NRPARCNEGOCIO = PARCNEGOCIO.NRPARCNEGOCIO
                              AND ENDERECOPARC.NRORG = PARCNEGOCIO.NRORG
                              AND ENDERECOPARC.CDTIPOENDERECO = 'PRINCIPAL'
                              WHERE PARCNEGOCIO.NRPARCNEGOCIO = :NRPARCNEGOCIO
                              AND PARCNEGOCIO.NRORG = :NRORG
                              AND ENDERECOPARC.CDPAIS IS NOT NULL
                              AND ENDERECOPARC.IDATIVO = 'S'";

                $params = array("NRPARCNEGOCIO" => $values['nrparcnegocio'],
                    "NRORG" => $values['nrorg']);

                $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($select, $params);

                if ($result[0]['CDPAIS'] == '0055')//há um parceiro de negócio brasileiro?
                {
                    return true;//sim
                }
            }
        }
        return false;//não tem parceiro de negócio ou não tem um parceiro de negócio brasileiro
    }
}