<?php

/**
 * FpaParamfolham
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 17/11/2011 18:37:50 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class FpaParamfolham extends DaoFpaParamfolham
{


    /**
     * Retorna instancia de FpaparamfolhamEntity agregado com FpaparamfolhahEntity.
     *
     * @param integer    $nrOrg          Numero da Organizacao de Trabalho.
     * @param integer    $nrOrgPadrao    Numero da Organizacao Padrao.
     * @param TkDateTime $mesCompetencia Data de Competencia.
     *
     * @throws Exception $e Propaga excecao.
     *
     * @return null | array FpaParamfolhamEntity
     *
     * @author thalesvalias - 21/11/11
     *         alessandrobartels - 01/12/11 - Retorna todos os registros da Org e OrgPadrao.
     */
    public static function retornaParametrosFolha($nrOrg, $nrOrgPadrao, TkDateTime $mesCompetencia){

        $paramFolha = array();

        try{
            $paramFolha = self::getObjectsByWhere(
                'NRORG = ?
                OR NRORG = ?',
                array(
                    $nrOrg, $nrOrgPadrao,
                )
            );
        } catch (Exception $e){
            echo $e->getMessage().'<br />';

        }

        foreach ($paramFolha as $resultado) {
                $dao = $resultado->getDao();
                // BORBA 19/03/2013 Metodo end() a principio deve ser mantido, mesmo que seja retornado somente um historico o createObjectsFromArray cria um array de objetos;
                $historico = end(
                                FpaParamfolhah::retornaParametrosFolhaHistorico($nrOrg, $nrOrgPadrao,$mesCompetencia, $dao->NRPARAMFOLHAM)
                                );
            //BORBA 27/03/2013
            if($historico != null){

                $resultado->historico = $historico;

            }else{
                throw new Exception('Não existe histórico para o parametro de folha '.$dao->NRPARAMFOLHAM.' na competência: '.$mesCompetencia);
            }


            }

        return $paramFolha;
    }


}
