/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 6703_ORESTPO_GERA_RETIRADA_ORCA.SQL                                        */
/* Autor: Diego Gonalves                                                     */
/* Data: 26/01/2010                                                           */
/* Descrio:                                                                 */
/*    Buscar os produtos da tabela de pedidos e fazer retiarada dos mesmos    */
/*  de acordo com o parmetrizado na tela parmetros de matria prima         */
/*----------------------------------------------------------------------------*/
CREATE or REPLACE
PROCEDURE GERA_RETIRADA_ORCA ( P_CDFILIAL        IN VARCHAR2,
                               P_NRRETIRADAORE   IN VARCHAR2,
                               P_DTSAIDINI       IN DATE,
                               P_DTSAIDFIN       IN DATE,
                               P_NRORCAINI       IN VARCHAR2,
                               P_NRORCAFIN       IN VARCHAR2,
                               P_CDCLIENTE       IN VARCHAR2,
                               P_TPEVENTO        IN VARCHAR2,
                               P_TPSERVEVEN      IN VARCHAR2,
                               P_CDOPERADOR      IN VARCHAR2,
                               P_DTATUAL         IN DATE)
AS
   V_TNRORCAEVENTO  VARCHAR2(1);
   V_TCDCLIENTE     VARCHAR2(1);
   V_TTPSERVEVEN    VARCHAR2(1);
   V_TTPEVENTO      VARCHAR2(1);
BEGIN

   V_TNRORCAEVENTO := '';
   V_TCDCLIENTE    := '';
   V_TTPSERVEVEN   := '';
   V_TTPEVENTO     := '';

   IF ((P_NRORCAINI IS NULL) AND (P_NRORCAFIN IS NULL)) THEN
      V_TNRORCAEVENTO := 'T';
   ELSE
      V_TNRORCAEVENTO := '';
   END IF;

   IF (P_CDCLIENTE IS NULL) THEN
      V_TCDCLIENTE := 'T';
   ELSE
      V_TCDCLIENTE := '';
   END IF;

   IF (P_TPSERVEVEN IS NULL) THEN
      V_TTPSERVEVEN := 'T';
   ELSE
      V_TTPSERVEVEN := '';
   END IF;

   IF (P_TPEVENTO IS NULL) THEN
      V_TTPEVENTO := 'T';
   ELSE
      V_TTPEVENTO := '';
   END IF;

   INSERT INTO RETIRADAORE (CDFILIAL, NRRETIRADAORE, CDOPERADOR, DTINIEVERETIORE,
                            DTFINEVERETIORE, DTRETIRADAORE)
                    VALUES (P_CDFILIAL, P_NRRETIRADAORE, P_CDOPERADOR, P_DTSAIDINI,
                            P_DTSAIDFIN, P_DTATUAL);

   FOR C_REG IN(
       SELECT IP.CDPRODUTO, IP.QTITEMPED, IP.NRPEDIDO, IP.NRITEMPED
         FROM PEDIDO P, ITEMPEDIDO IP, ORCAEVENTO O, DEPARTAMENTO DP, DEGUSTACAO DG
        WHERE P.CDFILIAL     = P_CDFILIAL
          AND ((P.NRORCAEVENTO BETWEEN P_NRORCAINI AND P_NRORCAFIN) OR (V_TNRORCAEVENTO = 'T'))
          AND ((O.IDTPORCAEVEN = 'O' AND ( (O.IDSITUORCEVE IN ('4', '5', '6') AND (TO_DATE(TO_CHAR(O.DTEVENTO, 'DDMMYYYY'), 'DDMMYYYY') BETWEEN P_DTSAIDINI AND P_DTSAIDFIN)) OR ( NOT(IDSITUORCEVE IN ('7', '8')) AND (TO_DATE(TO_CHAR(DG.DTDEGUSTACAO, 'DDMMYYYY'), 'DDMMYYYY') BETWEEN P_DTSAIDINI AND P_DTSAIDFIN)))) OR
              (O.IDTPORCAEVEN = 'E' AND (TO_DATE(TO_CHAR(O.DTHRENTROREV, 'DDMMYYYY'),'DDMMYYYY') BETWEEN P_DTSAIDINI AND P_DTSAIDFIN)))
          AND ((INSTR(P_CDCLIENTE, O.CDCLIENTE    ) > 0 ) OR (V_TCDCLIENTE  = 'T'))
          AND ((INSTR(P_TPSERVEVEN, O.CDTPSERVEVEN) > 0 ) OR (V_TTPSERVEVEN = 'T'))
          AND ((INSTR(P_TPEVENTO, O.CDTIPOEVENTO  ) > 0 ) OR (V_TTPEVENTO   = 'T'))
          AND P.NRPEDIDO     = IP.NRPEDIDO
          AND P.CDFILIAL     = IP.CDFILIAL
          AND P.CDFILIALORC  = O.CDFILIAL
          AND P.NRORCAEVENTO = O.NRORCAEVENTO
          AND P.NRSEQORCAEVE = O.NRSEQORCAEVE
          AND O.CDFILIAL     = DG.CDFILIAL(+)
          AND O.NRORCAEVENTO = DG.NRORCAEVENTO(+)
          AND O.NRSEQORCAEVE = DG.NRSEQORCAEVE(+)
          AND DP.IDTIPODEPTO = 'P'
          AND DP.CDDEPTO     = P.CDDEPTO
        ORDER BY IP.NRITEMPED
   )LOOP

      GERA_COMPOSICAO_RETIRADA ( P_CDFILIAL, P_NRRETIRADAORE, '', C_REG.CDPRODUTO, C_REG.QTITEMPED,
                                 P_DTATUAL, 'S', P_CDOPERADOR, C_REG.NRPEDIDO, C_REG.NRITEMPED, '', '');


   END LOOP;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_RETIRADA_ORCA','5.09.014'); END;
/
