/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_COMISSAO                                                 */
/* Tabela : COMISSAO                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_COMISSAO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_COMISSAO
GO

CREATE TRIGGER DTULTATU_COMISSAO
ON COMISSAO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'COMISSAO', null, 'CDCOMISSAO='+ CDCOMISSAO + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE COMISSAO
      SET DTULTATUCOMI = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(COMISSAO.CDCOMISSAO,0) = ISNULL(INSERTED.CDCOMISSAO,0)) AND
            (ISNULL(COMISSAO.NMCOMISSAO,0) = ISNULL(INSERTED.NMCOMISSAO,0));
   END;
END;
GO


